<?php
rg_log("FILE: /inc/user/repo/bug/show/show");

// TODO: security checks

$_bug_show = "";

$rg['HTML:bug_edit'] = "";

$ibug = rg_bug_info($db, $rg['ri']['repo_id'], $rg['bug']['bug_id']);
if ($ibug === FALSE)
	rg_fatal("Cannot lookup bug!");

$rg['bug'] = array_merge($rg['bug'], $ibug);

if ($ibug['exists'] != 1) {
	$_bug_body .= rg_template("repo/bug/not_found.html", $rg);
	return;
}

// If bug is deleted and the user does not have 'delete' rights, deny access.
if ($ibug['deleted'] > 0) {
	if (rg_rights_allow($db, $rg['ri']['repo_id'], "repo", $rg['ri']['uid'],
		$rg['login_ui']['uid'], "d", $rg['ip'], "") !== TRUE) {
		$_bug_body .= rg_template("repo/bug/deleted.html", $rg);
		return;
	}
}

// load labels
$labels = rg_bug_label_get($db, $rg['ri']['repo_id'], $rg['bug']['bug_id']);
if ($labels === FALSE)
	$rg['HTML:labels_html'] = "Cannot load labels!";
else
	$rg['HTML:labels_html'] = rg_bug_label_html($db, $labels);
$rg['bug']['labels'] = implode(" ", $labels);

// edit
$rg['HTML:edit_form'] = rg_template("repo/bug/b_edit.html", $rg);
if (rg_var_uint("edit") == 1)
	$rg['HTML:bug_edit'] = rg_bug_edit_high_level($db, $rg);

// close/re-open
$close_reopen_error = "";
while (1) {
	if (rg_var_uint("close_reopen") != 1)
		break;

	$ibug['state'] = rg_var_uint("state");
	$ibug['state_text'] = rg_bug_state($ibug['state']);

	if ($ibug['state'] == 1) { // reopen
		if (rg_rights_allow($db, $rg['ri']['repo_id'], "repo",
			$rg['ri']['uid'], $rg['login_ui']['uid'], "r", $rg['ip'], "") !== TRUE) {
			rg_template("repo/bug/deny_reopen.html", $rg);
			break;
		}
	} else { // close
		if (rg_rights_allow($db, $rg['ri']['repo_id'], "repo",
			$rg['ri']['uid'], $rg['login_ui']['uid'], "C", $rg['ip'], "") !== TRUE) {
			rg_template("repo/bug/deny_close.html", $rg);
			break;
		}
	}

	if (!rg_valid_referer()) {
		$close_reopen_error = "Invalid referer; try again";
		break;
	}

	if (!rg_token_valid($db, $rg, FALSE)) {
		$close_reopen_error = "Invalid token. Try again.";
		break;
	}

	$ret = rg_bug_edit($db, $rg['login_ui'], $rg['ri'], $ibug);
	if ($ret === FALSE) {
		$close_reopen_error = "Cannot edit bug (" . rg_bug_error() . ")";
		break;
	}

	// TODO: do something with the error code
	break;
}
if ($ibug['state'] == 1)
	$t = "repo/bug/b_close.html";
else
	$t = "repo/bug/b_reopen.html";
$rg['HTML:close_form'] = rg_template($t, $rg);
$rg['HTML:button_error'] = rg_warning($close_reopen_error, $rg);

// 'add_note' must be unconditionally included because we must insert the form
include($INC . "/user/repo/bug/show/add_note.php");

// load notes
$notes = rg_bug_note_list($db, $rg['ri']['repo_id'],
	$rg['bug']['bug_id'], 0);
if ($notes === FALSE)
	$rg['HTML:notes'] = "Cannot load notes!";
else
	$rg['HTML:notes'] = rg_template_table("repo/bug/list_note", $notes, $rg);

// watch
$watch_body = "";
$watch = rg_watch_load($db, "bug", $rg['login_ui']['uid'], $rg['ri']['repo_id'],
	$rg['bug']['bug_id']);
if ($watch === FALSE) {
	$watch_body .= rg_warning("Internal error.");
} else {
	if ($watch === 0) {
		// user does not watch the bug, present 'watch' form
		if (rg_var_uint("watch") == 1) {
			// user pressed watch button
			$r = rg_watch_add($db, "bug", $rg['login_ui']['uid'],
				$rg['ri']['repo_id'], $rg['bug']['bug_id']);
			if ($r === FALSE)
				rg_internal_error("TODO: find something here");
			$watch = 1;
		}
	} else {
		// user is already watching the bug, present 'unwatch' option
		if (rg_var_uint("unwatch") == 1) {
			// user pressed unwatch button
			$r = rg_watch_del($db, "bug", $rg['login_ui']['uid'],
				$rg['ri']['repo_id'], $rg['bug']['bug_id']);
			if ($r === FALSE)
				rg_internal_error("TODO: find something here");
			$watch = 0;
		}
	}

	if ($watch == 0)
		$t = "repo/bug/b_watch.html";
	else
		$t = "repo/bug/b_unwatch.html";
	$r = rg_template($t, $rg);
	if ($r !== FALSE)
		$watch_body .= $r;
}
$rg['HTML:watch_form'] = $watch_body;

// delete
$delete_error = "";
while (1) {
	$del_undel = rg_var_uint("del_undel");
	if ($del_undel == 0)
		break;

	if (rg_rights_allow($db, $rg['ri']['repo_id'], "repo", $rg['ri']['uid'],
		$rg['login_ui']['uid'], "d", $rg['ip'], "") !== TRUE) {
		$delete_error = rg_template("repo/bug/deny_delete.html", $rg);
		break;
	}

	if (!rg_valid_referer()) {
		$delete_error = rg_warning("Invalid referer; try again", $rg);
		break;
	}

	if (!rg_token_valid($db, $rg, FALSE)) {
		$delete_error = rg_warning("Invalid token; try again.", $rg);
		break;
	}

	$ret = rg_bug_delete_undelete($db, $rg['login_ui']['uid'],
		$rg['ri']['repo_id'], $ibug['bug_id'], $del_undel);
	if ($ret === FALSE) {
		$delete_error = rg_warning(rg_bug_error(), $rg);
		break;
	}
	break;
}
$rg['HTML:button_error'] = $delete_error;


// We must look it up again because it can be edited above; no prob, is in cache
$ibug = rg_bug_info($db, $rg['ri']['repo_id'], $rg['bug']['bug_id']);
if ($ibug === FALSE)
	rg_fatal("Cannot lookup bug!");
$rg = rg_array_merge($rg, "bug", $ibug);

$rg['rg_form_token'] = rg_token_get($db, $rg);
$_bug_show .= rg_template("repo/bug/show.html", $rg);
?>
